#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# -----------------------------------------------
# Grab the current boards
  my $query = qq!
    SELECT Title,Number
    FROM Boards
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $rows = $sth -> rows;


# ------------------------
# Send them a page 
  w3t::send_header ("Assign a moderator.");
  w3t::table_header("Assign a moderator.");

  print "Choose a board from the list below to view the current moderator.  You will then be able to change this to a different user.";

  print "<FORM METHOD = POST action =\"$config{'cgiurl'}/admin/viewmod.pl\">";
  print "<select name=\"Number\">";
  for (my $i=0;$i < $rows; $i++) {
  
    my ($Title,$Number) = $sth -> fetchrow_array;
    print "<option value=$Number>$Title</option>";  
    
  }
  print "</select>";
  print "<br><br>";
  print "<input type=submit value=\"Submit\">";
  print "</form>";  

  $sth -> finish;
  w3t::send_footer();
