#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------
# Grab the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username = $FORM{'Username'};


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# --------------------------------------------------
# Update this user's status
 
  my $newstat    = $dbh -> quote("Administrator");
  my $Username_q = $dbh -> quote($Username);

  my $query = qq!
    UPDATE Users 
    SET Status = $newstat
    WHERE Username = $Username_q     
  !;
  $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# ------------------------------------------------------------
# Let's let all admins and moderators know about the new admin
  my $Sender  = $user{'Username'};
  my $To      = "A_M_GROUP";
  my $Subject = "New Administrator";
  my $mess    = "$Sender has given Administrative privileges to $Username";

  w3t::send_message($Sender,$To,$Subject,$mess);

 
# ---------------------------------------------------------------
# Send the user a message letting them know they have admin privs

  my $Sender  = $user{'Username'};
  my $To      = $Username;
  my $Subject = "Admin privileges";
  my $mess    = "You have been granted Administrator privileges.  Please do not abuse this or these privileges may be revoked.";
  w3t::send_message($Sender,$To,$Subject,$mess); 

# ------------------------
# Send them a confirmation
  w3t::send_header ("Admin privileges granted.","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("Admin privileges granted.");

  print "Administrator privileges have been granted to $Username.  You will now be returned to the main admin page.";

  w3t::send_footer();
