#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# -------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Keyword  = $FORM{'Keyword'};
  my $Total    = $FORM{'Total'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){
    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");
  }


# --------------------------------------------------------
# Lets cycle through the list and close the proper threads
  for (my $i=0;$i<$Total;$i++){
    
    my $check    = "Thread$i";
    my $Closed_q = $dbh -> quote("K");
    if( $FORM{$check} ) {
      my $query = qq!
        UPDATE $Keyword
        SET Kept = $Closed_q
        WHERE Main = $FORM{$check}
      !;
      $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr.";

    }

  }


# ------------------------
# Send them a page 
  w3t::send_header ("Threads kept","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("Threads kept");

  print "All the threads that you checked have been marked as kept and now cannot be deleted by the autodelete feature.  You will now be returned to the main administration page.";

  w3t::send_footer();
