#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# -------------
# Grab the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username = $FORM{'Username'};


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


  my $Username_q = $dbh -> quote($Username);

# --------------------------------------
# Check if this was the first user added
  my $query = qq!
    SELECT Number
    FROM Users
    WHERE Username = $Username_q
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error. $query. Reason: $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my ($Number) = $sth -> fetchrow_array;
  if ($Number == 1) {
    w3t::not_right("You cannot revoke Administrative rights from the first user added.");
  }


# -----------------------------------------------------
# Check to see if this User is a moderator of any board
  my $query = qq!
    SELECT *
    FROM Boards
    WHERE Moderator = $Username_q
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error. $query. Reason: $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $rows = $sth -> rows;
  my $Status  = '';
  my $newstat = '';
  if ($rows > 0) {
    $Status = "Moderator";
    $newstat = $dbh -> quote("Moderator");
  }
  else {
    $Status = "User";
    $newstat = $dbh -> quote("User");
  }


# --------------------------------------------------
# Update this user's status
 
  my $Username_q = $dbh -> quote($Username);

  my $query = qq!
    UPDATE Users 
    SET Status = $newstat
    WHERE Username = $Username_q     
  !;
  $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# ---------------------------------------------------------------
# Send the user a message letting them know they have admin privs

  my $Sender  = $user{'Username'};
  my $To      = $Username;
  my $Subject = "Your privileges";
  my $mess    = '';
  if ($Status eq "Moderator"){

    $mess    = "Your Administrative privileges have been revoked.  You have been returned to moderator status.";

  }
  else {

    $mess = "Your Administrative privileges have been revoked.  You have been returned to user status.";

  }
  w3t::send_message($Sender,$To,$Subject,$mess);


# ------------------------------------
# Now inform all other Admins and mods
  my $Sender  = $user{'Username'};
  my $To      = "A_M_GROUP";
  my $Subject = "Administrator demoted";
  my $mess    = "$Sender has revoked Administrative privileges from $Username";
  w3t::send_message($Sender,$To,$Subject,$mess);
   

# ------------------------
# Send them a confirmation
  w3t::send_header ("Admin privileges revoked.","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("Admin privileges revoked.");

  print "Administrator privileges have been removed from $Username.  You will now be returned to the main Administration page.";

  $sth -> finish;
  w3t::send_footer();
