#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# -------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $option = $FORM{'option'};
  my $Username = $FORM{'Username'};
  my $Hostname = $FORM{'Hostname'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){
    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");
  }


# ----------------------------------------------
# Unban the user
  my $Selector = '';
  my $Delete   = '';
  my $Delete_q = '';

  if ($option eq "Unban this Username"){
    $Selector = "Username";
    $Delete     = $Username;
    $Delete_q   = $dbh -> quote($Delete);
  }
  else {
    $Selector = "Hostname";
    $Delete     = $Hostname;
    $Delete_q   = $dbh -> quote($Delete);
  }
  my $query = qq!
    DELETE FROM Banned
    WHERE $Selector = $Delete_q 
  !;

  $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr.";


# ----------------------------------------------
# If we unbanned a user, lets send them a message.
  if ($Selector eq "Username") {

    my $Sender  = $user{'Username'};
    my $To      = $Username;
    my $Subject = "You have been unbanned.";
    my $mess    = "You have been unbanned and are now free to make posts or send private messages again.";

    w3t::send_message($Sender,$To,$Subject,$mess);

  }


# -----------------------------------
# Now lets inform all mods and admins
  my $Sender  = $user{'Username'};
  my $To      = "A_M_GROUP";
  my $Subject = "$Selector Unbanned";
  my $mess    = "$Sender has unbanned the $Selector '$Delete'";
  w3t::send_message($Sender,$To,$Subject,$mess);


# ------------------------
# Send them a page 
  w3t::send_header ("$Selector unbanned","<META HTTP-EQUIV=\"Refresh\" content=\"5;url=$config{'cgiurl'}/admin/login.pl\">");
  w3t::table_header("$Selector has been unbanned.");

  print "The $Selector $Delete has been unbanned.  You will now be returned to the main administration page.";

  w3t::send_footer();
