#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -------------
# Get the input
  my %FORM = w3t::get_input();
  my $User = $FORM{'User'};


# -----------------------
# Connect to the database
  w3t::db_connect;


# -----------------------------------------
# Make sure this is an admin or a moderator
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator')
){

    w3t::not_right ("You must be logged in, and be a valid administrator
or moderator to access this.");

  }


# Get the current profile for this username
  my $Username_q = $dbh -> quote($User);
  my $query = qq!
    SELECT Password,Email,Fakeemail,Name,Signature,Homepage,Occupation,Hobbies,Location,Bio,Sort,Display,View,PostsPer,EReplies,Notify,Status,Number,Security
    FROM Users
    WHERE Username = $Username_q
  !;
  my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";


# --------------------------
# Assign the retrieved data
  my($Password,$Email,$Fakeemail,$Name,$Signature,$Homepage,$Occupation,$Hobbies,$Location,$Bio,$Sort,$Display,$View,$PostsPer,$EReplies,$Notify,$Status,$Number,$Security) = $sth -> fetchrow_array;

# ------------------------------------------------------------------------
# If this is the very first admin, then they cannot view or edit this user
  if ($Number eq '1') {
    w3t::not_right("You cannot view or edit the first Administrator.");
  }  

# ------------------------------------------------------------------------
# If this user is a moderator we have to make sure they are only looking at
# someone with User status
  if ( ($user{'Status'} eq 'Moderator') && ($Status ne 'User') ) {
    w3t::not_right("As a moderator you cannot view the profiles of other moderators or Admins");
  }  



# -----------------------------------------------
# Find out if they already have a sort preference
  my $DS = '';
  my $AS = '';
  my $DP = '';
  my $AP = '';
  my $DD = '';
  my $AD = '';
  if($Sort == 1) { $DS = "selected"; } 
  if($Sort == 2) { $AS = "selected"; }
  if($Sort == 3) { $DP = "selected"; } 
  if($Sort == 4) { $AP = "selected"; }
  if($Sort == 5) { $DD = "selected"; }
  if($Sort == 6) { $AD = "selected"; }


# --------------------------------------------------
# Find out if they already have a display preference
  my $flat     = '';
  my $threaded = '';
  if($Display eq "flat")     { $flat = "selected"; };
  if($Display eq "threaded") { $threaded = "selected"; }


# ---------------------------------------
# Find out if they have a view preference
  my $collapsed = '';
  my $expanded  = '';
  if($View eq "collapsed") { $collapsed = "selected"; }
  if($View eq "expanded")  { $expanded  = "selected"; }


# ---------------------------------
# Set the default for Email replies
  my $ereplies   = '';
  my $noereplies = '';

  if($EReplies eq "Off") { 
    $noereplies = "checked"; 
  }
  else {
    $ereplies = "checked";
  }


# ------------------------------------------------
# Set the default for private message notification
  my $donotify = '';
  my $nonotify = '';

  if ($Notify eq "On") {
    $donotify = "checked";
  }
  else {
    $nonotify = "checked";
  }


# ------------------------
# Convert returns to <br>s
  $Signature =~s /<br>/\n/g;
  $Bio =~s /<br>/\n/g;


# ---------------------------
# Change the quotes to &quot;
  $Password =~s /"/&quot;/g;
  $Email =~s /"/&quot;/g;
  $Fakeemail =~s /"/&quot;/g;
  $Signature =~s /"/&quot;/g;
  $Homepage =~s /"/&quot;/g;
  $Occupation =~s /"/&quot;/g;
  $Hobbies =~s /"/&quot;/g;
  $Location =~s /"/&quot;/g;
  $Bio =~s /"/&quot;/g;


# ---------------------------------------------------------
# Ok, we found the profile, now lets put it all onto a page
  w3t::send_header("Profile for $User");

  print qq~

  <table border=0 width=100% bgcolor=$config{'tddark'}>
  <tr><td>
  <font size = +2><b>
  Edit profile for $User
  </b></font>
  </td></tr>
  </table>

  <p>
  You can edit any of the information below.
  </p><p>
  <form method = POST action = "$config{'cgiurl'}/admin/dochangeuser.pl">
  <input type = hidden name = Username value ="$User">
  <input type = hidden name = OldPass value = "$Password">
  Security Level (1-100 : Boards with a higher security level will be invisible.  You cannot set this to a higher level than your own which is $user{'Security'}.)<br>
  <input type = text name=Security value=$Security size=3>
  <br><br>

  Password (between 4 and 20 characters)<br>
  <input type = password name=Password value = "$Password" maxlength=20>
  <br><br>
  Verify Password<br>
  <input type = password name = Verify value = "$Password" maxlength=20>
  <br><br>
  Email Address (Not available to other users)<br>
  <input type = text name = Email value = "$Email">
  <br><br>
  Fake Email (shown on your profile page to other users)<br>
  <input type = text name = Fakeemail value = "$Fakeemail">
  <br><br>
  Full Name<br>
  <input type = text name = Name value = "$Name">
  <br><br>
  Signature (up to 100 characters)<br>
  <textarea name=Signature cols=50 rows=3 wrap=soft>$Signature</textarea>
  <br><br>
  Homepage (up to 150 characters)<br>
  http://<input type=text name=Homepage value = "$Homepage">
  <br><br>
  Occupation<br>
  <input type=text name=Occupation value = "$Occupation">
  <br><br>
  Hobbies (up to 200 characters)<br>
  <input type=text name=Hobbies value = "$Hobbies">
  <br><br>
  Geographic Location (State, Country, etc.)<br>
  <input type=text name=Location value = "$Location">
  <br><br>
  Bio (up to 250 characters)<br>
  <textarea name=Bio cols=80 rows=5 wrap=soft>$Bio</textarea>
  <br><br>
  Default sort order<br>
  <select name = "sort_order">
    <option value = 1 $DS>Descending Subject</option>
    <option value = 2 $AS>Ascending Subject</option>
    <option value = 3 $DP>Descending Poster</option>
    <option value = 4 $AP>Ascending Poster</option>
    <option value = 5 $DD>Descending Date</option>
    <option value = 6 $AD>Ascending Date</option>
  </select><br><br>
  Default display mode<br>
  <select name = "display">
    <option value = "threaded" $threaded>Threaded Mode</option>
    <option value = "flat" $flat>Flat Mode</option>
  </select><br><br>
  Default view<br>
  <select name = "view">
    <option value = "collapsed" $collapsed>Collapsed Threads</option>
    <option value = "expanded"  $expanded>Expanded Threads</option>
  </select><br><br>
  Total parent posts to show per page: (default is $config{'postsperpage'})<br>
  <input type=text name=PostsPer maxlength = 3 size = 3 value = $PostsPer><br><br>
  <br><br>
  Do you want email notification when you receive private messages?<br>
    <input type=radio name=Notify value="Off" $nonotify> No
    <input type=radio name=Notify value="On" $donotify> Yes

  <br><br>
  Do you want all replies to posts that you make emailed to you?<br>
    <input type=radio name=EReplies value="Off" $noereplies> No
    <input type=radio name=EReplies value="On" $ereplies> Yes
  <br><br>

~;


# ------------------------------------------------------------------
# if we are allowing subscribes then we need to put that on the page
  if ($config{'subscriptions'}) {

  # -----------------------------------------
  # Grab the keyword and titles of all boards
    my $query = qq!
      SELECT Title,Keyword
      FROM Boards
      ORDER BY Title
    !;
    my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my $rows = $sth -> rows;
    print "Subscription status for the following boards.  (Receive a daily archive of all posts to this board via your Real email address.)<br><br>";

    for (my $i = 0; $i < $rows; $i++) {

      my ($Title,$Keyword) = $sth -> fetchrow_array;
    
    # ------------------------------------
    # check if they are already subscribed
      my $Username_q = $dbh -> quote($User);
      my $Keyword_q  = $dbh -> quote($Keyword);

      my $query = qq!
        SELECT Last
        FROM Subscribe
        WHERE Username = $Username_q AND Board = $Keyword_q
      !;
      my $sti = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
      $sti -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
      my $rows = $sti -> rows;
      my $Sub = '';
      my $Nosub = '';
      if ($rows > 0) { 
        $Sub = "checked"; 
      }
      else {
        $Nosub = "checked";
      }
      
      print "$Title<br>";
      my $Word = "$Keyword"."--SUB--YES";
      print "<input type=radio name=\"Board$i\" value = \"$Word\" $Sub>Subscribe ";
      my $Word = "$Keyword"."--SUB--NO";
      print "<input type=radio name=\"Board$i\" value = \"$Word\" $Nosub>Unsubscribe<br><br>";


    }
    print "<br>";
    print "<input type=hidden name = Totalsubs value = $rows>";
  }
  print"<input type=submit value=submit>";
  print"</FORM>";


# ----------------
# send the footer
  $sth -> finish;
  w3t::send_footer();
