#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ----------------------
# Connect to the database
  w3t::db_connect();


# --------------------------
# Make sure this is an admin!
  my %user = w3t::authenticate();
  if ($user{'Status'} ne 'Administrator') {
    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");
  }


# ------------------------
# Send them a page 
  w3t::send_header ("Revoke Administrator privileges");
  w3t::table_header("Revoke Administrator privileges.");


# --------------------------
# Get all the administrators 
  my $Admin_q = $dbh -> quote("Administrator");

  my $query = qq!
    SELECT Username,Number
    FROM Users 
    WHERE Status = $Admin_q AND Number <> 1
    ORDER BY Username
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $DBI::errstr.";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";

  print "The following users have Administrative privileges, except for the very first Administrator.  The first Admin can never have their rights revoked.  Select the name of the User who's rights you wish to revoke, and click 'Revoke Rights'.  If this user is a moderator of any board then they will be returned to Moderator Status, if not then they will be returned to User status.";
  print "<FORM METHOD = POST action =\"$config{'cgiurl'}/admin/dorevokeadmin.pl\">";
  print "<select name = \"Username\" size = 1>";
  my $Username = '';
  my $Number;
  my $rows = $sth -> rows;

  for (my $i=0; $i < $rows; $i++){
    ($Username,$Number) = $sth->fetchrow_array;
    print "<option>$Username</option>\n";
  }
  print "</select>";
  print "<br><br>";
  print "<input type=submit value=\"Revoke Rights\">";
  print "</form>"; 

  $sth -> finish;
  w3t::send_footer();
