#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Number = $FORM{'Number'};
  my $option = $FORM{'option'};

# ----------------------
# Connect to the database
  w3t::db_connect();


# -----------------------------------------
# Make sure this is an admin or a moderator!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){

    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");

  }


# -------------------------------------------------------------------
# If they chose to delete this board then we go to the verify section
  if ($option eq "Delete this board"){

    &verify_delete($Number,$user{'Status'});

  }


# -----------------------------------------------
# Grab the board info 
  my $query = qq!
    SELECT Title,Keyword,Description,HTML,Anonymous,Locked,Moderator,Expire,Markup,Security
    FROM Boards
    WHERE Number = $Number
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my ($Title,$Keyword,$Description,$HTML,$Anonymous,$Locked,$Moderator,$Expires,$Markup,$Security) = $sth -> fetchrow_array;


# -------------------------------
# Find out what category it is in
  my $Keyword_q = $dbh -> quote($Keyword);
  $query = qq!
    SELECT Title,Number
    FROM Category
    WHERE Keyword = $Keyword_q
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my ($Cat,$Catnum) = $sth -> fetchrow_array;

# ----------------------------------------------------------------------
# If this is a moderator make sure they are the moderator for this board
  if ( ($user{'Status'} eq 'Moderator') && ($user{'Username'} ne $Moderator) ) {

    w3t::not_right("You do not have moderator privileges for this board.");

  }


  my ($HTMLOn,$HTMLOff,$AnonymousOn,$AnonymousOff,$LockedOn,$LockedOff,$MarkupOn,$MarkupOff);
 
  if ($HTML eq "On") {
    $HTMLOn = "checked";
  }
  else {
    $HTMLOff = "checked";
  }

  if ($Markup eq "On") {
    $MarkupOn = "checked";
  }
  else {
    $MarkupOff = "checked";
  }

  if ($Anonymous eq "On") {
    $AnonymousOn = "checked";
  }
  else {
    $AnonymousOff = "checked";
  }

  if ($Locked eq "Open") {
    $LockedOn = "checked";
  }
  else {
    $LockedOff = "checked";
  }


# ------------------------
# Send them a page 
  w3t::send_header ("Edit this board.");
  w3t::table_header("Edit this board.");

  print qq~
    You may edit any of the following properties below.<p>
    <FORM METHOD = POST action ="$config{'cgiurl'}/admin/doeditboard.pl">
    <input type=hidden name=Number value=$Number>
    <input type=hidden name=Moderator value="$Moderator">
    Board Title<br>
    <input type=text name = Title value = "$Title">
    <br><br>

    Description<br>
    <textarea name=Description cols=60 rows=5 wrap=soft>$Description</textarea>
    <br><br>
    
    Allow HTML<br>
    <input type=radio name=HTML value=On $HTMLOn> Yes
    <input type=radio name=HTML value=Off $HTMLOff> No
    <br><br>

    Allow Markup<br>
    <input type=radio name=Markup value=On $MarkupOn> Yes
    <input type=radio name=Markup value=Off $MarkupOff> No
    <br><br>

    Allow Anonymous Postings<br>
    <input type=radio name=Anonymous value=On $AnonymousOn> Yes
    <input type=radio name=Anonymous value=Off $AnonymousOff> No
    <br><br>

    Allow public to post on this board<br>
    <input type=radio name=Locked value="Open" $LockedOn> Yes
    <input type=radio name=Locked value="Closed" $LockedOff> No
    <br><br>
    
    Expire threads after how many days (0 - Never expire)<br>
    <input type=text name=Expires value = $Expires size=3>
    <br><br>

    Security Level (1-100: Users with a lower security level will not see this board.  You may not set this any higher than your own security level which is $user{'Security'}.)
    <input type=text name=Security value=$Security size=3>
    <br><br>

    Which category do you want to place this forum<br>
    <select name=Category>
    ~;
    my $query = qq!
      SELECT DISTINCT Title,Number FROM Category ORDER BY Title
    !;
    my $sth = $dbh -> prepare($query) or die "Can't prepare $query.  Reason: $DBI::errstr.";
    $sth -> execute() or die "Can't execute $query.  Reason: $DBI::errstr.";
    my $rows = $sth -> rows;
    for (my $i=0;$i<$rows;$i++) {
      my ($Catlist,$Catnumlist) = $sth -> fetchrow_array;
      my $catname = "$Catlist"."-PARSER-"."$Catnumlist";
      my $thisisit = "";
      if ($Catlist eq $Cat) {
        $thisisit = "SELECTED";
      }
      print "<option value=\"$catname\" $thisisit>$Catlist";
    }


    print qq~
    </select>
    <br><br>
    <input type=submit value = "Submit">
    </form>
  ~;


  $sth -> finish;
  w3t::send_footer();


########################################################################
# Verify that they want to delete this board
########################################################################

sub verify_delete {

  my ($Number,$Status) = @_;


# ---------------------------
# Make sure they are an admin
  if ($Status ne 'Administrator') {
    
    w3t::not_right("You have to be an administrator to delete a board.");

  }

  w3t::send_header("Delete this board");
  w3t::table_header("Delete this board");


# ---------------------------
# Grab the title of the board
  my $query = qq!
    SELECT Title,Keyword,Description
    FROM Boards
    WHERE Number = $Number
  !;

  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr.";
  $sth -> execute() or die "Can't execute query. $query. Reason: $DBI::errstr";

  my ($Title,$Keyword,$Description) = $sth -> fetchrow_array;
  
  print "You have chosen to delete the following board:<p>";
  print "<b>$Title</b><br>";
  print "$Description";
  print "<p>If you are sure you want to delete this board, then select the 'confirm delete' button below.<br><br>";
  print "<form method=post action = \"$config{'cgiurl'}/admin/deleteboard.pl\">\n";
  print "<input type=hidden name=Number value=$Number>\n";
  print "<input type=hidden name=Keyword value=\"$Keyword\">\n";
  print "<input type=submit value = \"Confirm Delete\">\n";

  $sth -> finish;
  w3t::send_footer();
  w3t::exit();

}
