#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Number = $FORM{'Number'};
  my $option = $FORM{'option'};

# ----------------------
# Connect to the database
  w3t::db_connect();


# -----------------------------------------
# Make sure this is an admin or a moderator!
  my %user = w3t::authenticate();
  if ( $user{'Status'} ne 'Administrator') {

    w3t::not_right ("You must be logged in, and be a valid administrator to access this.");

  }


# -------------------------------------------------------------------
# If they chose to delete cat board then we go to the verify section
  if ($option eq "Delete this category"){

    &verify_delete($Number,$user{'Status'});

  }


# -----------------------------------------------
# Grab the cat info 
  my $query = qq!
    SELECT Title
    FROM   Category 
    WHERE  Number = $Number
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my ($Title) = $sth -> fetchrow_array;


# ------------------------
# Send them a page 
  w3t::send_header ("Edit this category.");
  w3t::table_header("Edit this category.");

  print qq~
    You may edit the category name below.<p>
    <FORM METHOD = POST action ="$config{'cgiurl'}/admin/doeditcat.pl">
    <input type=hidden name=Number value=$Number>
    Category Name<br>
    <input type=text name = Title size=60 value = "$Title">
    <br><br>
    <input type=submit value = "Submit">
    </form>
  ~;


  $sth -> finish;
  w3t::send_footer();


########################################################################
# Verify that they want to delete this board
########################################################################

sub verify_delete {

  my ($Number,$Status) = @_;


# ---------------------------
# Make sure they are an admin
  if ($Status ne 'Administrator') {
    
    w3t::not_right("You have to be an administrator to delete a category.");

  }

  w3t::send_header("Delete this category");
  w3t::table_header("Delete this category");


# ---------------------------
# Grab the title of the category
  my $query = qq!
    SELECT Title
    FROM   Category 
    WHERE  Number = $Number
  !;

  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr.";
  $sth -> execute() or die "Can't execute query. $query. Reason: $DBI::errstr";

  my ($Title) = $sth -> fetchrow_array;
  
  print "You have chosen to delete the following category:<p>";
  print "<b>$Title</b><br>";
  print "<p>If you are sure you want to delete this category, then select the 'confirm delete' button below.<br><br>";
  print "<form method=post action = \"$config{'cgiurl'}/admin/deletecat.pl\">\n";
  print "<input type=hidden name=Number value=$Number>\n";
  print "<input type=submit value = \"Confirm Delete\">\n";

  $sth -> finish;
  w3t::send_footer();
  w3t::exit();

}
