#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);
  use strict;


# ------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Keyword = $FORM{'Keyword'};


# ----------------------
# Connect to the database
  w3t::db_connect();


# -----------------------------------------
# Make sure this is an admin or a moderator!
  my %user = w3t::authenticate();
  if ( ($user{'Status'} ne 'Administrator') && ($user{'Status'} ne 'Moderator') ){

    w3t::not_right ("You must be logged in, and be a valid administrator or moderator to access this.");

  }


# -----------------------------------------------
# Grab the board info 
  my $Closed_q = $dbh -> quote("K");
  my $query = qq!
    SELECT Number,Main,Subject,Username,Posted,Kept 
    FROM $Keyword 
    WHERE Number = Main AND Kept <> $Closed_q
    ORDER BY Posted DESC
  !;
  my $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";

  my $rows = $sth -> rows;



# ------------------------
# Send them a page 
  w3t::send_header ("Keep threads.");
  w3t::table_header("Keep threads.");

  print qq~
    Place a checkmark by any threads that you wish to keep.
    <FORM METHOD = POST action ="$config{'cgiurl'}/admin/dokeepthreads.pl">
    <input type=hidden name=Keyword value=$Keyword>
    <input type=hidden name=Total value=$rows>

    <table border=0 width=100% cellspacing=0>
    <tr><td bgcolor=$config{'tddark'}>Keep</td> 
    <td bgcolor=$config{'tddark'}>Subject</td>
    <td bgcolor=$config{'tddark'}>Posted By</td>
    <td bgcolor=$config{'tddark'}>Posted On</td></tr>
  
  ~;
  my $color = "$config{'tdlight'}";

  for (my $i=0;$i<$rows;$i++){
  
    my ($Number,$Main,$Subject,$Username,$Posted) = $sth -> fetchrow_array;
    $Posted = w3t::convert_time($Posted);

    print qq~
      <td bgcolor=$color>
      <input type=checkbox name=Thread$i value="$Number">
      </td><td bgcolor=$color>
      <a href="$config{'cgiurl'}/showpost.pl?Board=$Keyword&Number=$Number">$Subject</a>
      </td><td bgcolor=$color>
      $Username
      </td><td bgcolor=$color>
      $Posted
      </td></tr>
    ~;
    if ($color eq "$config{'tdlight'}"){
      $color = "$config{'tddark'}";
    }
    else {
      $color = "$config{'tdlight'}";
    }

  }
  print "</table>";
  print"<input type=submit value = \"Submit\">";
  print"</form>";


  $sth -> finish;
  w3t::send_footer();
