#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -------------
# Get the input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username   = $FORM{'Username'};
  my $OldPass    = $FORM{'OldPass'};
  my $Password   = $FORM{'Password'};
  my $Verify     = $FORM{'Verify'};
  my $Fakeemail  = $FORM{'Fakeemail'};
  my $Email      = $FORM{'Email'};
  my $Name	 = $FORM{'Name'};
  my $Signature  = $FORM{'Signature'};
  my $Homepage   = $FORM{'Homepage'};
  my $Occupation = $FORM{'Occupation'};
  my $Hobbies    = $FORM{'Hobbies'};
  my $Location   = $FORM{'Location'};
  my $Bio        = $FORM{'Bio'};
  my $Sort       = $FORM{'sort_order'};
  my $Display    = $FORM{'display'};
  my $View       = $FORM{'view'};
  my $PostsPer   = $FORM{'PostsPer'};
  my $EReplies   = $FORM{'EReplies'};
  my $Totalsubs   = $FORM{'Totalsubs'};
  my $Notify     = $FORM{'Notify'};
  my $TextCols   = $FORM{'TextCols'};
  my $TextRows   = $FORM{'TextRows'};
  my $FontSize   = $FORM{'FontSize'};
  my $FontFace   = $FORM{'FontFace'};
  my $ICQ        = $FORM{'ICQ'};
  my $Post_Format= $FORM{'Post_Format'};
  my $Preview    = $FORM{'Preview'};
  my $sth;


# ------------------------
# Connect to the database
  w3t::db_connect();


# ---------------------------
# Let's authenticate the user
  my %user = w3t::authenticate($Username,$OldPass);
  if (!(defined $user{'Username'}) ){

    w3t::not_right ("Strange, you must have editied the form manually and tried to change your login...");
  }


# -----------------------------------------------------------
# If the 2 given password do not match then we can't proceed  
  if($Password ne $Verify){

    w3t::not_right("Passwords do not match");

  }


# -----------------------------------------------
# If this is a new password we need to encrypt it
  if ($Password ne $OldPass) {
    my $a = time();
    srand($a);
    my @passet = ('a'..'k', 'm'..'z', 'A'..'N', 'P'..'Z', '2'..'9');
    my $one   = int(rand($#passet)) +1;
    my $two   = int(rand($#passet)) +1;
    my $salt  = "@passet[$one]"."@passet[$two]";
    my $crypt = crypt($Password,$salt);
    $Password = $crypt;
  }


# --------------------------------------------------------
# If the password isn't the proper length we can't proceed  
  if((length($Password)<4) || (length($Password)>20)){

    w3t::not_right("Password needs to be between 4 and 20 characters.");

  }


# -----------------------------------------------------
# If homepage is greater than 150 then we can't proceed
  if ( length($Homepage) > 150 ) {

    w3t::not_right("The Homepage entry is too long"); 

  }


# --------------------------------------------------------
# If Occupation is greater than 150 then we can't proceed
  if ( length($Occupation) > 150 ) {

    w3t::not_right("The Occupation entry is too long");

  }


# ----------------------------------------------------
# If hobbies is greater than 200 then we can't proceed
  if ( length($Hobbies) > 200 ) {

    w3t::not_right("The Hobbies entry is too long");

  }


# -----------------------------------------------------
# If location is greater than 200 then we can't proceed
  if ( length($Location) > 200 ) {

    w3t::not_right("The Location entry is too long");

  }


# -------------------------------------------------------------
# If signature is greater than the specified size, do not allow
  if ( length($Signature) > $config{'Sig_length'} ) {

    w3t::not_right("Your signature is too long.");

  }

# ------------------------------------------------
# If Bio is greater than 250, the we do not allow
  if ( length($Bio) > 250) {
    w3t::not_right("Your Bio is too long.");
  }

# --------------------------------------------------------------
# If Posts per is less than 1 or greater than 999, can't proceed
  if( ($PostsPer < 1) || ($PostsPer > 999) ) {

    w3t::not_right("Posts per page value cannot be used.");

  }

# -------------------------------------------------------------
# If textcols is less than 20 or greater than 200 can't proceed
  if ( ($TextCols < 20) || ($TextCols > 200) ) {
  
    w3t::not_right("Textarea columns value cannot be used.");

  }


# If textrows is less than 5 or greater than 50 can't proceed
  if ( ($TextRows < 5) || ($TextRows > 50) ) {

    w3t::not_right("Textarea rows value cannot be used.");

  }

# ------------------------------------
# Make sure post_format is side or top
  if ( ($Post_Format ne "top") && ($Post_Format ne "side") ) {
    w3t::not_right("Post Format must be side or top.");
  }

# -----------------------
# Format the query words
  my $Password_q   = $dbh -> quote($Password);
  my $Email_q      = $dbh -> quote($Email);
  my $Fakeemail_q  = $dbh -> quote($Fakeemail);
  my $Name_q       = $dbh -> quote($Name);
  my $Signature_q  = $dbh -> quote($Signature);
  my $Homepage_q   = $dbh -> quote($Homepage);
  my $Occupation_q = $dbh -> quote($Occupation);
  my $Hobbies_q    = $dbh -> quote($Hobbies);
  my $Location_q   = $dbh -> quote($Location);
  my $Bio_q        = $dbh -> quote($Bio);
  my $Username_q   = $dbh -> quote($Username);
  my $Display_q    = $dbh -> quote($Display);
  my $View_q       = $dbh -> quote($View);
  my $EReplies_q   = $dbh -> quote($EReplies);
  my $Notify_q     = $dbh -> quote($Notify);
  my $FontSize_q   = $dbh -> quote($FontSize);
  my $FontFace_q   = $dbh -> quote($FontFace);
  my $ICQ_q        = $dbh -> quote($ICQ);
  my $Post_Format_q= $dbh -> quote($Post_Format);
  my $Preview_q    = $dbh -> quote($Preview);

# --------------------------
# Update the User's profile
  my $query =qq!
    UPDATE Users
    SET Password   = $Password_q,
    Email          = $Email_q,
    Fakeemail      = $Fakeemail_q,
    Name           = $Name_q,
    Signature      = $Signature_q,
    Homepage       = $Homepage_q,
    Occupation     = $Occupation_q,
    Hobbies        = $Hobbies_q,
    Location       = $Location_q,
    Bio            = $Bio_q,
    Sort           = $Sort,
    Display        = $Display_q,
    View           = $View_q,
    PostsPer       = $PostsPer,
    EReplies       = $EReplies_q,
    Notify         = $Notify_q,
    TextCols       = $TextCols,
    TextRows       = $TextRows,
    FontSize       = $FontSize_q,
    FontFace       = $FontFace_q,
    Extra1         = $ICQ_q,
    Post_Format    = $Post_Format_q,
    Preview        = $Preview_q
    WHERE Username = $Username_q
  !; 
  $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# -----------------------------------------------------------------
# Now lets see if they are subscribing or unsubscribing to anything
  for (my $i=0; $i<$Totalsubs; $i++){

    my $Subscribes = "Board$i";
    my $Board = $FORM{$Subscribes};
    my $Sub;
    ($Board,$Sub) = split("--SUB--",$Board);

  # --------------------------------------------------------------
  # If the board is unmarked then we need to unsubscribe this user
    if ($Sub eq "NO") {
      my $Board_q    = $dbh -> quote($Board);
      my $Username_q = $dbh -> quote($Username);
      my $query = qq!
        DELETE FROM Subscribe
        WHERE Username = $Username_q AND Board = $Board_q
      !; 
      $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";
 
    }
  # ---------------------------------------------------------
  # If they board is marked then we need to subscribe the user
  # but we need to make sure they aren't already subscribed 
    else {

      my $Board_q    = $dbh -> quote($Board);
      my $Username_q = $dbh -> quote($Username);
      my $query = qq!
        SELECT *
        FROM Subscribe
        WHERE Username = $Username_q AND Board = $Board_q
      !;
      $sth = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
      $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
      my $rows = $sth -> rows;
      $sth -> finish;
    # ---------------------------------------------------------
    # They were not already subscribed so we now subscribe them
      if ($rows < 1) {

      # ----------------------------------------
      # Find out what the current post number is
        my $query = qq!
          SELECT Total 
          FROM Boards
          WHERE Keyword = $Board_q
        !;
        $sth = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
        $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
        my ($Last) = $sth -> fetchrow_array;
        $sth -> finish;

      # ---------------------
      # Now we subscribe them
        $query = qq!
          INSERT INTO Subscribe
          (Username,Board,Last)
          VALUES ($Username_q,$Board_q,$Last)
        !;
        $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";

      }

    }

  }


# ---------------------------------------------------
# Send them to their start page with the confirmation
  w3t::start_page($Username,$Password,1,"Your profile has been modified");
