#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# ------------------
# Get the form input
  my %FORM = w3t::get_input();


# ---------------------
# Assign the variables
  my $Username  = $FORM{'Username'};
  my $Board     = $FORM{'Board'};
  my $page      = $FORM{'page'};
  my $view      = $FORM{'view'};
  my $what      = $FORM{'what'};
  my $Number    = $FORM{'Number'};
  my $mode      = $FORM{'mode'};
  my $oldnumber = $Number;
  my $sb        = $FORM{'sb'};
  my $sth;

# ------------------------------------------------
# Set the subject to deleted and the body to blank
  my $Subject = "Post deleted by $Username"; 
  my $Body = "";


# ------------------------
# Connect to the database
  w3t::db_connect();


# --------------------
# Authenticate the user
  my %cookie   = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my %user     = w3t::authenticate($Username,$Password);
  if (!(defined $user{'Username'}) ) {

    w3t::not_right ("We could not authenticate your Username/Passord.");

  }


# ----------------------------------------------------------------
# Find out if there are any file attachments so we can delete them.
  my $query = qq!
    SELECT File
    FROM $Board
    WHERE Number = $Number
  !;
  $sth = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";
  my ($filename) = $sth -> fetchrow_array;
  if ($filename) {
    unlink("$config{'files'}/$filename");
  }


# ------------------------------------------------------------------------
# If there are no replies to this post then we delete it from the database
  $query = qq!
    SELECT Number
    FROM $Board
    WHERE Parent = $Number
  !;
  $sth = $dbh -> prepare($query) or die "Query syntax error: $query. Reason: $DBI::errstr";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";  
  my $rows = $sth -> rows;

  if ($rows < 1) {
    my $query = qq!
      DELETE FROM $Board
      WHERE Number = $Number
    !;
    $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";
    
    my $Board_q = $dbh -> quote($Board);
    $query = qq!
      UPDATE Boards
      SET Total = Total - 1
      WHERE Keyword = $Board_q
    !;
    $dbh -> do($query) or die "Can't execute query: $query.  Reason: $DBI::errstr";
 
  }
  else {

  # -------------------
  # Update the database
    my $Body_q    = $dbh -> quote($Body);
    my $Subject_q = $dbh -> quote($Subject);
    my $File_q    = $dbh -> quote("");
    my $query = qq!
      UPDATE $Board
      SET Subject = $Subject_q, Body = $Body_q, File=$File_q
      WHERE Number = $Number
    !;
    $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";

  }


  w3t::send_header("The post has been deleted","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$page&view=$view&sb=$sb\">");

  w3t::table_header("The post has been deleted");

  print"The post has been deleted.  You will now be returned to the forum.";

  $sth -> finish;
  w3t::send_footer();


