#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# -----------------------
# Connect to the database
  w3t::db_connect();


# --------------
# Grab the input
  my %FORM = w3t::get_input();
 

# --------------------
# Assign the variables
  my $Forum   = $FORM{'Forum'};
  my $Words   = $FORM{'Words'};  
  my $Match   = $FORM{'Match'};
  my $Page    = $FORM{'Searchpage'};
  my $Limit   = $FORM{'Limit'};
  my $Old     = $FORM{'Old'};
  my $sth;

  $Match   ||= "Or";
  $Page    ||= 0;
  $Limit   ||= 25;

  my $URLWords = w3t::url_decode($Words);
  my $URLForum = w3t::url_decode($Forum);
  my $URLMatch = w3t::url_decode($Match);
  $Match = w3t::url_decode($Match);

# ----------------------------------------
# Make sure they are looking for something.
  if ($Words eq "") {

    w3t::not_right("You have to put in some keywords to search for.");

  }


# ----------------------------------------------------------------
# Calculate the timestamp we are going to be using as our baseline
  my $time = w3t::get_date();
  if ($Old eq "1day") {
    $time = $time -86400;
  }
  elsif ($Old eq "2days") {
    $time = $time - (86400 * 2);
  }
  elsif ($Old eq "1week") {
    $time = $time - (86400 * 7);
  }
  elsif ($Old eq "2weeks") {
    $time = $time - (86400 * 14);
  }
  elsif ($Old eq "3weeks") {
    $time = $time - (86400 * 21);
  }
  elsif ($Old eq "1month") {
    $time = $time - (86400 *28);
  }
  elsif ($Old eq "3months") {
    $time = $time - (86400 * 74); 
  }
  elsif ($Old eq "6months") {
    $time = $time - (86400 * 168);
  }
  elsif ($Old eq "1year") {
    $time = $time - (86400 * 336);
  }
  elsif ($Old eq "allposts") {
    $time = ""; 
  }

# ---------------
# Send the header 
  w3t::send_header("Search results");
  w3t::table_header("Search results for query: $Words");


# --------------------------------------------------
# If we are only searching one board we execute this
  if ($Forum ne "All_Forums") {

  # -------------------------------
  # Now we need to format our query
    my $query =qq!
      SELECT Number,Posted 
      FROM   $Forum
    !;

    if ($Match eq "Or") {
      my @All = split(/ +/,$Words);
      my $SIZE = @All;
      for (my $i=0; $i < $SIZE; $i++) { 
        $All[$i] = "%".$All[$i]."%"; 
        $All[$i] = $dbh -> quote($All[$i]);
      }
      $Words = join(" OR Body Like ",@All);
      $query = $query."WHERE Body Like $Words";
    }
    elsif ($Match eq "And") {
      my @All = split(/ +/,$Words);
      my $SIZE = @All;
      for (my $i=0; $i < $SIZE; $i++) { 
        $All[$i] = "%".$All[$i]."%";
        $All[$i] = $dbh -> quote($All[$i]);
      }
      $Words = join(" And Body Like ",@All);
      $query = $query."WHERE Body Like $Words";
    }
    elsif ($Match eq "Username") {
      my $Words_q = $dbh -> quote($Words);
      $query = $query."WHERE Username = $Words_q";
    }
    else {
      $query = $query."WHERE Body Like '%$Words%'";
    }

    if ($time) {
      $query = $query."\nAND Posted > $time\n";
    }
    $query = $query."\nORDER BY Posted DESC\n";
    my $Totalgrab = '';
    my $GrabLimit = $Limit +1;
    if ($Page == 0) {
      $Totalgrab = "LIMIT $GrabLimit";
    } else {
      my $Startat = $Page * $Limit;
      $Totalgrab = "LIMIT $Startat,$GrabLimit";      
    }

    $query = $query. "\n$Totalgrab"; 
    # --------------------------------
    # Done with query format


    # ---------------------
    # Now execute the query
    $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr.";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
    my $rows = $sth -> rows;

    # ---------------------------
    # URL Encode the Search stuff
    $URLWords = w3t::url_encode($URLWords);
    $URLForum = w3t::url_encode($URLForum);
    $URLMatch = w3t::url_encode($Match);

    # ----------------------------------------------
    # IF we have some results lets make it look nice
    if($rows){

      print qq~
        <table border=0 width=100% cellspacing=0>
        <tr><td colspan=3 align=right bgcolor = $config{'tddark'}>
      ~;


      # -------------------------------------------------
      # Lets see if they need a next or previous page link
        if ($Page > 0) {

          my $newpage = $Page - 1;
          print "<a href = \"$config{'cgiurl'}/dosearch.pl?Forum=$URLForum&Words=$URLWords&Match=$URLMatch&Searchpage=$newpage&Limit=$Limit&Old=$Old\"><img src = \"$config{'images'}/previous.gif\" alt = \"Previous Page\" border = 0></a>";
        } 
        else {

          print "<img alt =\"*\" src = \"$config{'images'}/greyprevious.gif\">";

        }

        print "<a href = \"$config{'cgiurl'}/search.pl\"><img src = \"$config{'images'}/all.gif\" alt = \"Main search page\" border=0></a>";

        if ($rows > $Limit) {

          my $newpage = $Page + 1;
          print "<a href = \"$config{'cgiurl'}/dosearch.pl?Forum=$URLForum&Words=$URLWords&Match=$URLMatch&Searchpage=$newpage&Limit=$Limit&Old=$Old\"><img src = \"$config{'images'}/next.gif\" alt = \"Next Page\" border = 0></a>";
        } 
        else {

          print "<img alt=\"*\" src = \"$config{'images'}/greynext.gif\">";

        }


    # ------------------------------------
    # Now lets finish out the table header    
      print qq~ 
        <tr><td bgcolor=$config{'tddark'} width=55%>
        <b>Subject</b></td>
        <td bgcolor=$config{'tddark'} width=20% align=left>
        <b>Poster</b></td>
        <td bgcolor=$config{'tddark'} align=left>
        <b>Posted on</b></td></tr>
      ~;

      my $color = $config{'tdlight'};

 
    # ---------------------------------
    # Now lets cycle through the results
      for (my $i=0;$i < $rows-1 ;$i++){
        if ( ($i > 0) && ($i == $rows -1) ) {
          last;
        }
        my ($Number,$Board) = $sth -> fetchrow_array;
        $Forum =~s /'//g;
        $query = qq!
          SELECT Username,Subject,Posted
          FROM   $Forum
          WHERE  Number = $Number
        !;


        my $sti = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
        $sti -> execute() or die "Can't execute query: $query. Reason:: $DBI::errstr";

        my ($Username,$Subject,$Posted) = $sti -> fetchrow_array;
        $sti -> finish;
        print "<tr><td bgcolor = $color><a href=\"$config{'cgiurl'}/showpost.pl?Board=$URLForum&Number=$Number&Search=true&Forum=$URLForum&Words=$URLWords&Match=$URLMatch&Searchpage=$Page&Limit=$Limit&Old=$Old\">$Subject</a></td>";

        my $EUsername = w3t::url_encode($Username);

        print "</td><td bgcolor = $color><a href=\"$config{'cgiurl'}/showprofile.pl?User=$EUsername&what=search&Forum=$URLForum&Words=$URLWords&Match=$URLMatch&Searchpage=$Page&Limit=$Limit&Old=$Old\">$Username</a></td>";

        $Posted = w3t::convert_time($Posted);

        print "</td><td bgcolor = $color>$Posted</td></tr>";


      # -------------------
      # alternate the colors
        if ($color eq $config{'tdlight'}) {
          $color = $config{'tddark'};
        }else{
          $color = $config{'tdlight'};
        }
      }

      print "</table>";


    # ----------------------------------------
    # We didn't find anything so let them know.
    } 
    else {

      print "We found no matches for your search query.";

    }


    # ---------------
    # Send the footer
    $sth -> finish;
    w3t::send_footer;

  }
  else {
    # -------------------------------------------------------------
    # We are searching all forums so we have to handle this special

    # We need to set a variable to off that will get changed to on
    # as soon as we print the table header, otherwise it will get
    # printed out several times.
    my $tableheader = "off";

    # ----------------------------
    # First we grab all the forums
    my %cookie   = w3t::get_cookie();
    my $Username = $cookie{'Username'};
    my $Password = $cookie{'Password'};
    my %user     = w3t::authenticate($Username,$Password);
    
    my $Security = $user{'Security'};
    $Security  ||= $config{'anon_security'};

    my $query = qq!
      SELECT Title,Keyword,Security
      FROM   Boards
      WHERE  Security <= $Security
    !;
    my $sts = $dbh -> prepare($query) or die "Can't prepare $query.  Reason: $DBI::errstr.";
    $sts -> execute() or die "Can't execute $query.  Reason: $DBI::errstr.";
    my $boardrows = $sts -> rows;

    # --------------------------------------------------
    # Now we need to cycle through each board and search
    for (my $s =0; $s < $boardrows; $s++) {
      my ($Title,$Keyword,$Security) = $sts -> fetchrow_array;
      my $Searchwords = $Words;
      my $query =qq!
        SELECT Number,Posted 
        FROM   $Keyword
      !;

      if ($Match eq "Or") {
        my @All = split(/ +/,$Searchwords);
        my $SIZE = @All;
        for (my $i=0; $i<$SIZE; $i++) {
          $All[$i] = "%".$All[$i]."%"; 
          $All[$i] = $dbh -> quote($All[$i]);
        }
        $Searchwords = join(" OR Body Like ",@All);
        $query = $query."WHERE Body Like $Searchwords";
      }
      elsif ($Match eq "And") {
        my @All = split(/ +/,$Searchwords);
        for my $i (0 .. $#All) {
          $All[$i] = "%".$All[$i]."%";
          $All[$i] = $dbh -> quote($All[$i]);
        }
        $Searchwords = join(" And Body Like ",@All);
        $query = $query."WHERE Body Like $Searchwords";
      }
      elsif ($Match eq "Username") {
        my $Words_q = $dbh -> quote($Searchwords);
        $query = $query."WHERE Username = $Words_q";
      }
      else {
        $query = $query."WHERE Body Like '%$Searchwords%'";
      }

      if ($time) {
        $query = $query."\nAND Posted > $time\n";
      }
      $query = $query."\nORDER BY Posted DESC\n";

      # --------------------------------
      # Done with query format


      # ---------------------
      # Now execute the query
      $sth = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr.";
      $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
      my $rows = $sth -> rows;

      # ---------------------------
      # URL Encode the Search stuff
      $URLWords = w3t::url_encode($URLWords);
      $URLForum = w3t::url_encode($Keyword);
      $Match    = w3t::url_encode($Match);

      # ----------------------------------------------
      # IF we have some results lets make it look nice
      if ($rows) { 
        if ($tableheader eq "off") {
          $tableheader = "on";
          print qq~
            <table border=0 width=100% cellspacing=0>
            <tr><td colspan=3 align=right bgcolor = $config{'tddark'}>
            <a href = "$config{'cgiurl'}/search.pl"><img src = "$config{'images'}/all.gif" alt = "Main search page" border=0></a>
            </td></tr>
            <tr><td bgcolor=$config{'tddark'} width=55%>
            <b>Subject</b></td>
            <td bgcolor=$config{'tddark'} width=20% align=left>
            <b>Poster</b></td>
            <td bgcolor=$config{'tddark'} align=left>
            <b>Posted on</b></td></tr>
          ~;
        }
        print "<tr><td colspan=3 bgcolor=$config{'tdalt'}>";
        print "<img src=\"$config{'images'}/hr.gif\" alt=\"----------\">";
        print "</td></tr>";
        print "<tr><td colspan=3 align=center bgcolor=$config{'tdlight'}>";
        print "<b>$Title</b>";
        print "</td></tr>";
        print "<tr><td colspan=3 bgcolor=$config{'tdalt'}>";
        print "<img src=\"$config{'images'}/hr.gif\" alt=\"----------\">";
        print "</td></tr>";

        my $color = $config{'tddark'};
 
        # ---------------------------------
        # Now lets cycle through the results
        for (my $i=0;$i < $rows ;$i++){

        my ($Number,$Board) = $sth -> fetchrow_array;
        $Forum =~s /'//g;
        $query = qq!
          SELECT Username,Subject,Posted
          FROM   $Keyword
          WHERE  Number = $Number
        !;


        my $sti = $dbh -> prepare($query) or die "Query syntax error: $query. $DBI::errstr";
        $sti -> execute() or die "Can't execute query: $query. Reason:: $DBI::errstr";

        my ($Username,$Subject,$Posted) = $sti -> fetchrow_array;
        $sti -> finish;
        print "<tr><td bgcolor = $color><a href=\"$config{'cgiurl'}/showpost.pl?Board=$URLForum&Number=$Number&Search=true&Forum=All_Forums&Words=$URLWords&Match=$URLMatch&Searchpage=$Page&Limit=$Limit&Old=$Old\">$Subject</a></td>";

        my $EUsername = w3t::url_encode($Username);

        print "</td><td bgcolor = $color><a href=\"$config{'cgiurl'}/showprofile.pl?User=$EUsername&what=search&Forum=All_Forums&Words=$URLWords&Match=$URLMatch&Searchpage=$Page&Limit=$Limit&Old=$Old\">$Username</a></td>";

        $Posted = w3t::convert_time($Posted);

        print "</td><td bgcolor = $color>$Posted</td></tr>\n";


      # -------------------
      # alternate the colors
        if ($color eq $config{'tdlight'}) {
          $color = $config{'tddark'};
        }else{
          $color = $config{'tdlight'};
        }
      }

    }

  } 
  print "</table>";
  # ----------------------------------------
  # We didn't find anything so let them know.
  if ($tableheader eq "off") {
    print "We found no matches for your search query.";

  }


  # ---------------
  # Send the footer
  $sts -> finish;
  $sth -> finish;
  w3t::send_footer;

}
