#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# ---------------------
# Send the page to them
  w3t::db_connect(); 
  w3t::send_header("FAQ (Frequently Asked Questions)");
  w3t::table_header("FAQ (Frequently Asked Questions)");

  my $cgiurl = $config{'cgiurl'};

  print qq~ 
  <table cellspacing=0 border=0 width=100% bgcolor=$config{'tddark'}>
  <tr><td>
  Below you will find a list of frequently asked questions.  You can click on any of these and get some help with anything you might be having a problem with.  If you know of anything else that should be addressed on this page please send your suggestions to <a href="mailto:$config{'emailaddy'}">$config{'emailaddy'}</a>.
  </p><p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  <a href="$cgiurl/faq.pl#attach">Can I attach a file to my post?</a><br>
  <a href="$cgiurl/faq.pl#html">Can I use html in my posts?</a><br>
  <a href="$cgiurl/faq.pl#source">Can I run my own forum?</a><br>
  <a href="$cgiurl/faq.pl#cookies">Do I have to accept cookies?</a><br>
  <a href="$cgiurl/faq.pl#moreposts">I want to see more (or less) posts per page.</a><br>
  <a href="$cgiurl/faq.pl#buttons">What's with all the buttons?</a><br>
  <a href="$cgiurl/faq.pl#sortorder">Why are Subject,Poster and Posted on clickable?</a><br>
  <a href="$cgiurl/faq.pl#email">Why do you ask for a Fake Email address?</a><br>
  <a href="$cgiurl/faq.pl#register">Why should I register a Username?</a>
  <p>
  </td></tr></table>


  <p>&nbsp;
  <table cellspacing=0 border=0 width=100% bgcolor=$config{'tddark'}>
  <tr><td>
  <a name="attach"><h3>Can I attach a file to my post?</a></h3>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  ~;
  if($config{'files'}) {
    print qq~
      If you have a browser that is Mozilla 4+ compatible then the answer is yes you can.  When you preview your post you will have the opportunity to attach a file to your post.
    ~;
  }
  else {
    print "No.  File attachment has been turned off for these boards.";
  }

  print qq~
  <p>&nbsp;

  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <a name="html"><h3>Can I use HTML in my posts?</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  There are 2 ways that this can be configured on a per board basis.  If HTML is On then you will see <b>HTML is On</b> and you can use normal HTML in your posts.  If Markup is on you will see <b>Markup is On</b>.  The following tags are available for your use if Markup is enabled:
  <br><br>
  <font color=$config{'headerfontcolor'}>
  [b]
  </font>
  text
  <font color=$config{'headerfontcolor'}>
  [/b]
  </font>
         = Makes the given text bold.<br>

  <font color=$config{'headerfontcolor'}>
  [email]
  </font>
  joe\@blow.com
  <font color=$config{'headerfontcolor'}>
  [/email] 
  </font>
  = Makes the given email address clickable.<br>

  <font color=$config{'headerfontcolor'}>
  [i]
  </font>
  text
  <font color=$config{'headerfontcolor'}>
  [/i]
  </font>
         = Makes the given text italic.<br>

  ~;
  if ($config{'allowimages'}) {
    print"<font color=$config{'headerfontcolor'}>";
    print"[image]</font>";
    print"url";
    print "<font color=$config{'headerfontcolor'}>";
    print "[/image]</font>  = Puts the given url in an img src tag.<br>";
  }

  print qq~

  <font color=$config{'headerfontcolor'}>
  [pre]
  </font>
  text
  <font color=$config{'headerfontcolor'}>
  [/pre]
  </font>
   = Surrounds the given text with pre tags.<br>

  <font color=$config{'headerfontcolor'}>
  [quote]
  </font>
  text
  <font color=$config{'headerfontcolor'}>
  [/quote] 
  </font>
  = Surrounds the given text with blockquote and hr's.  This markup tag is used for quoting a reply.<br>

  <font color=$config{'headerfontcolor'}>
  [url]
  </font>
  link
  <font color=$config{'headerfontcolor'}>
  [/url]</font>    = Makes the given url into a link.<br>


  <font color=$config{'headerfontcolor'}>
  [smile]
  </font> = <img src="$config{'images'}/smile.gif"><br>

  <font color=$config{'headerfontcolor'}>
  [frown]
  </font> = <img src="$config{'images'}/frown.gif"><br>

  <font color=$config{'headerfontcolor'}>
  [wink]
  </font> = <img src="$config{'images'}/wink.gif"><br>

  <font color=$config{'headerfontcolor'}>
  [red]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/red]
  </font> 
  = Makes the given text red.<br>

  <font color=$config{'headerfontcolor'}>
  [green]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/green] 
  </font> 
  = Makes the given text green.<br>

  <font color=$config{'headerfontcolor'}>
  [blue]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/blue]
  </font> 
   = Makes the given text blue.<br>

  <font color=$config{'headerfontcolor'}>
  [orange]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/orange]
  </font> 
   = Makes the given text orange.<br>

  <font color=$config{'headerfontcolor'}>
  [black]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/black] 
  </font> 
  = Makes the given text black.<br>

  <font color=$config{'headerfontcolor'}>
  [white]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/white] 
  </font> 
  = Makes the given text white.<br>

  <font color=$config{'headerfontcolor'}>
  [yellow]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/yellow]
  </font> 
   = Makes the given text yellow.<br>

  <font color=$config{'headerfontcolor'}>
  [purple]
  </font> 
  text
  <font color=$config{'headerfontcolor'}>
  [/purple]
  </font> 
   = Makes the given text purple.

  <p>&nbsp;
  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <a name="source"><h3>Can I run my own forum?</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  Yes, WWWThreads is a Open Source project.  It is licensed under the GNU GPL and is available for download at <a href="http://www.wwwthreads.org">www.wwwthreads.org</a>

  <p>&nbsp;
  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <a name="cookies"><h3>Do I have to accept cookies?</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  Yes.  Cookies are used to track your Username/Password and which posts you have read for your current session.  Without accepting cookies some functions won't work properly.



  <p>&nbsp;
  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <a name="moreposts"><h3>I want to see more (or less) posts per page.</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  You can change the number of posts to be displayed per page by editing your profile.  You can set this from anything between 1 and 999 posts per page.  When you first sign up this gets set to $config{'postsperpage'} posts per page.


  <p>&nbsp;
  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>

  <a name="buttons"><h3>What's with all the buttons?</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>

  The buttons are used for navigation and displaying posts.  Depending on the screen you are on they may serve different purposes.
  <p>When displaying a list of all threads:
  <br>- The left and right arrows will take you to the previous or next page of posts. 
  <br>- The up arrow will take you to the index of all available forums.
  <br>- The "New Post" button will let you make a new post on that board.
  <br>- The + and - buttons will allow you to toggle between expanded and
collapsed threads.  Expanded threads will show the subject of all posts and replies in a threaded format.  Collapsed threads will show the subject of the main post along with the number of replies to that post.
  <p>When viewing individual threads:
  <br>- The left and right arrows will take you to the previous or next thread.
  <br>- The up arrow will take you back to the listing of all posts on that page.
  <br>- The "Flat Mode" button allows you to view the entire thread on one page if there are any replies to the original message.
  <br>- The "Threaded Mode" button allows you to view the current posts will all other posts on that thread displayed below in a threaded format.



  <p>&nbsp;
  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <a name="sortorder"><h3>Why are Subject, Poster and Posted On clickable</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  You can click on any of these to change the order in which the posts are sorted and displayed.  If you click on Subject once, it will display posts by Subject in reverse alphabetical order.  If you click on it again it will display posts by Subject in alphabetical order.  Poster and Posted on works similarly.



  <p>&nbsp;
  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <a name="email"><h3>Why do you ask for a Fake Email address?</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  The Fake email address will be what other users see when they view your profile.  We realize that some people don't want everyone to know their normal email address, but we need to know it in case you want to subscribe to a forum or if you want to have replies emailed to you.  For this reason you can give us your real email address that only we will see and you can provide a different one for the general public.  Some people like to put in something like scream\@no.spam.gamernews.net.  This way people can still figure out what your real email address is, but spamming agents can't just parse through the page and spam you.


  
  <p>&nbsp;
  </td></tr><tr><td bgcolor=$config{'tdalt'}>
  </td></tr><tr><td bgcolor=$config{'tddark'}>
  <a name="register"><h3>Why should I register a Username?</h3></a>
  <p>
  </td></tr><tr><td bgcolor=$config{'tdlight'}>
  By registering a Username, you will be able to edit your profile and preferences.  Also only people with registered Usernames can take advantage of the "New Posts" feature upon each visit.  

  </td></tr></table  </td></tr></table>
  ~;
# -------------
# Send a footer
  w3t::send_footer;
