#!/usr/bin/perl 
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;

# ------------------
# Get the form input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $From = $FORM{'Username'};
  my $Number = $FORM{'Number'};
  my $Sender = $FORM{'Sender'};
  my $Subject = $FORM{'Subject'};
  my $Message = $FORM{'Message'};
  my $sth;


# ------------
# Get the date
  my $date = w3t::get_date();


# ----------------------
# connect to the database
  w3t::db_connect();
  my $query = '';


# ---------------------
# Authenticate the User
  my %cookie   = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my %user     = w3t::authenticate($Username,$Password);
  if (! (defined $user{'Username'} )) {

    w3t::not_right ("We could not authenticate your Username/Password.");

  }
  $Sender = $user{'Username'};
  my $Password = $user{'Password'};

# Put the message into the database and mark it as N - New
  my $Status_q   = $dbh -> quote("N");
  my $Username_q = $dbh -> quote($From);
  my $Subject_q  = $dbh -> quote($Subject);
  my $Sender_q   = $dbh -> quote($Sender);
  my $Message_q  = $dbh -> quote($Message);

  $query = qq!
    INSERT INTO Messages
    (Username,Status,Subject,Sender,Message,Sent)
    VALUES ($Username_q,$Status_q,$Subject_q,$Sender_q,$Message_q,$date)
  !; 
  $dbh -> do($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# Set the message to R - Replied
  $Status_q = $dbh -> quote("R");
 
  $query = qq!
    UPDATE Messages
    SET Status = $Status_q
    WHERE Number = $Number
  !;
 
  $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# --------------------------------------------------------------------------
# Now lets grab the email address and see if they want to have a notification
# that they received a private message
  $query = qq!
    SELECT Email,Notify
    FROM Users
    WHERE Username = $Username_q
  !;
  $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr";
  my ($Email,$Notify) = $sth -> fetchrow_array;

  if ($Notify eq "On"){

    require Mailer;
    my $mailer = new Mailer ( { smtp => $config{'SMTP'}, sendmail=> $config{'sendmail'} } ) or die "Can't init: $Mailer::error";
    my $from    = $config{'emailaddy'};
    my $subject = "You have new messages";
    my $msg     = "You have received a private message from '$Sender' on the forums at $config{'title'}.  You can go to $config{'cgiurl'}/wwwthreads.pl to view it.";

    $mailer -> send( {to => $Email, from => $from, subject => $subject, msg => $msg} ) or die "Can't mail message: $Mailer::error";

  }

 

# Return to their start page
  w3t::start_page("$Sender","$Password","","");
