#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# ------------------
# Get the form input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Subject   = $FORM{'Subject'};
  my $Body      = $FORM{'Body'};
  my $Board     = $FORM{'Board'};
  my $page      = $FORM{'page'};
  my $view      = $FORM{'view'};
  my $what      = $FORM{'what'};
  my $Number    = $FORM{'Number'};
  my $mode      = $FORM{'mode'};
  my $oldnumber = $Number;
  my $sb        = $FORM{'sb'};
  my $option	= $FORM{'option'};

  $Body = w3t::url_decode($Body);
  $Subject = w3t::url_decode($Subject);


# -----------------------
# Connect to the database
  w3t::db_connect();


# --------------------
# Authenticate the user
  my %cookie   = w3t::get_cookie();
  my $Username = $cookie{'Username'};
  my $Password = $cookie{'Password'};
  my %user = w3t::authenticate($Username,$Password);
  if (!(defined $user{'Username'}) ) {

    w3t::not_right ("We could not authenticate your Username/Passord.");

  }

# --------------------------------------------------
# If we are deleting this post, then we execute this
  if ($option eq "Delete this post") {
  # --------------------
  # Send them their page
    w3t::send_header("Delete this post");
    w3t::table_header("Delete this post");


    print qq~

      You have chosen to delete this post.  If you are sure you want to do this
click the button below , otherwise use your back button to return to the last sc
reen.
      <p>
      <form method=POST action="$config{'cgiurl'}/deletepost.pl">
      <input type=hidden name=Username value="$Username">
      <input type=hidden name=Board value="$Board">
      <input type=hidden name=what value="$what">
      <input type=hidden name=page value="$page">
      <input type=hidden name=view value="$view">
      <input type=hidden name=Number value="$Number">
      <input type=hidden name=mode value="$mode">
      <input type=hidden name=sb value="$sb">
      <p>
      <input type=submit value="Yes, I want to delete this post"> 
      </form>
    ~;


  # ---------------
  # Send the footer
    w3t::send_footer();  
    w3t::exit();

  }

# --------------------------
# Grab the board information
  my $Board_q = $dbh -> quote($Board);
  my $query = qq!
    SELECT HTML,Markup
    FROM   Boards
    WHERE  Keyword = $Board_q
  !;

  my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr.
 Query: $query";
  $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.
";

  my ($HTML,$Markup) = $sth -> fetchrow_array;

# ---------------------------------
# get rid of < and > in the subject
  $Subject =~s /</&lt;/g;
  $Subject =~s />/&gt;/g;

# -----------------------------------------------------
# Let's find out if they get the default preview or not.
  my $Preview = $user{'Preview'};
  $Preview  ||= $config{'Preview'};

# -------------------------------------------------------------
# If HTML is off then we need to get rid of < and > in the body
  if( ($Preview eq "off") && ($HTML eq "Off") ) {
    $Body =~s />/&gt;/g;
    $Body =~s /</&lt;/g;
    $Body =~s /&lt;br&gt;/<br>/g;
  }

if ($Markup eq "On") {
 
# -----------------------------
# Now we format all markup code
  $Body =~ s/\[b\]/<b>/ig;
  $Body =~ s/\[\/b\]/<\/b>/ig;
  $Body =~ s/\[i\]/<i>/ig;
  $Body =~ s/\[\/i\]/<\/i>/ig;

# -----------------------
# Convert the color codes
  $Body =~ s/\[red\]/<font color=red>/ig;
  $Body =~ s/\[\/red\]/<\/font color=red>/ig;
  $Body =~ s/\[green\]/<font color=green>/ig;
  $Body =~ s/\[\/green\]/<\/font color=green>/ig;
  $Body =~ s/\[blue\]/<font color=blue>/ig;
  $Body =~ s/\[\/blue\]/<\/font color=blue>/ig;
  $Body =~ s/\[orange\]/<font color=orange>/ig;
  $Body =~ s/\[\/orange\]/<\/font color=orange>/ig;
  $Body =~ s/\[purple\]/<font color=purple>/ig;
  $Body =~ s/\[\/purple\]/<\/font color=purple>/ig;
  $Body =~ s/\[white\]/<font color=white>/ig;
  $Body =~ s/\[\/white\]/<\/font color=white>/ig;
  $Body =~ s/\[black\]/<font color=black>/ig; 
  $Body =~ s/\[\/black\]/<\/font color=black>/ig;
  $Body =~ s/\[yellow\]/<font color=yellow>/ig;
  $Body =~ s/\[\/yellow\]/<\/font color=yellow>/ig;

# ----------------------------
# Replace quote markup -> html
  $Body =~ s,\[quote\](.*)\[/quote\],<blockquote><font size=1>In reply to:</font><hr><p>$1<p><hr></blockquote><p>,isg;

# ---------------------------
# Convert code markup -> html
  $Body =~ s,\[pre\](.*)\[/pre\],<pre>$1</pre><p>,isg;

# ----------------------------
# Convert email markup -> html
  $Body =~ s,\[email\](.*)\[/email\],<A HREF="mailto:$1">$1</A>,isg;

# --------------------
# Convert the smiley's
  $Body =~s,\[smile\],<img src=\"$config{'images'}/smile.gif\">,isg;
  $Body =~s,\[frown\],<img src=\"$config{'images'}/frown.gif\">,isg;
  $Body =~s,\[wink\],<img src=\"$config{'images'}/wink.gif\">,isg; 

# ---------------------------
# Convert url markup -> html
  $Body =~ s,\[url\]http://(.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;
  $Body =~ s,\[url\](.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;

# --------------------------------------------------
# Convert image markup -> html if allow images is on
  if ($config{'allowimages'}) {
    $Body =~ s,\[image\](.*)\[/image\],<IMG SRC="$1">,isg;
  }

# ---------------------------------------------
# Get rid of the trailing br's on certain codes
  $Body =~s/<\/blockquote><p><br>/<\/blockquote><p>/g;
  $Body =~s/<\/pre><p><br>/<\/pre><p>/g;
  $Body =~s/<pre><br>/<pre>/g;

}



# -------------------
# Update the database
  my $Username_q = $dbh -> quote($user{'Username'});
  my $Subject_q = $dbh -> quote($Subject);
  my $Body_q    = $dbh -> quote($Body);
  
  my $query = qq!
    UPDATE $Board
    SET Subject = $Subject_q, Body = $Body_q
    WHERE Number = $Number
  !;
  $dbh -> do ($query) or die "Can't execute query: $query. Reason: $DBI::errstr";


# ----------------------------------------------
# Make sure they get refeshed to the proper page 
  if($what eq "showpost") {

    w3t::send_header("The post has been modified","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$config{'cgiurl'}/showpost.pl?Board=$Board&Number=$oldnumber&page=$page&view=$view&mode=$mode&sb=$sb\">");

  } else {

    w3t::send_header("The post has been modified","<META HTTP-EQUIV=\"Refresh\" CONTENT=\"5;url=$config{'cgiurl'}/wwwthreads.pl?action=list&Board=$Board&page=$page&view=$view&sb=$sb\">");

  }


  w3t::table_header("Your post has been entered");

  print "The post has been modified.  You will now be returned to the forum.";


# ---------------
# Send the footer
  w3t::send_footer();


