#!/usr/bin/perl
###########################################################################
#    WWWThreads  - Interactive Discussion Forum
#    Rick Baker scream@screamingweb.com 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
###########################################################################
  use w3tvars qw(%config);
  use w3t qw($dbh);

  use strict;


# ------------------
# Get the form input
  my %FORM = w3t::get_input();


# --------------------
# Assign the variables
  my $Username = $FORM{'Username'}; 
  my $Subject  = $FORM{'Subject'};
  my $Body     = $FORM{'Body'};
  my $Board    = $FORM{'Board'};
  my $what     = $FORM{'what'};
  my $page     = $FORM{'page'};
  my $view     = $FORM{'view'};
  my $Number   = $FORM{'Number'};
  my $mode     = $FORM{'mode'};
  my $option   = $FORM{'option'};
  my $sb       = $FORM{'sb'};
  my $sth;


# ------------------------------------------
# IF we are changing this post do this block
  if ($option eq "Change this post") {


  # -----------------------
  # Connect to the database
    w3t::db_connect();


  # --------------------
  # Authenticate the user
    my %cookie   = w3t::get_cookie();
    my $Username = $cookie{'Username'};
    my $Password = $cookie{'Password'};
    my %user     = w3t::authenticate($Username,$Password);
    if (!(defined $user{'Username'}) ) {

      w3t::not_right ("We could not authenticate your Username/Passord.");

    }


  # --------------------------
  # Grab the board information
    my $Board_q = $dbh -> quote($Board);
    my $query = qq!
      SELECT HTML,Markup
      FROM   Boards
      WHERE  Keyword = $Board_q
    !;

    my $sth = $dbh -> prepare ($query) or die "Query syntax error: $DBI::errstr. Query: $query";
    $sth -> execute() or die "Can't execute query: $query. Reason: $DBI::errstr.";

    my ($HTML,$Markup) = $sth -> fetchrow_array;


  # ---------------------------------
  # get rid of < and > in the subject
    $Subject =~s /</&lt;/g;
    $Subject =~s />/&gt;/g;


  # -----------------------------------------------------
  # If HTML is off then we get rid of < and > in the body
    if ($HTML eq "Off") {
      $Body =~s />/&gt;/g;
      $Body =~s /</&lt;/g;
      $Body =~s /&lt;br&gt;/<br>/g;
    }


  if ($Markup eq "On") {

  # -----------------------------
  # Now we format all markup code
    $Body =~ s/\[b\]/<b>/ig;
    $Body =~ s/\[\/b\]/<\/b>/ig;
    $Body =~ s/\[i\]/<i>/ig;
    $Body =~ s/\[\/i\]/<\/i>/ig;

  # -----------------------
  # Convert the color codes
    $Body =~ s/\[red\]/<font color=red>/ig;
    $Body =~ s/\[\/red\]/<\/font color=red>/ig;
    $Body =~ s/\[green\]/<font color=green>/ig;
    $Body =~ s/\[\/green\]/<\/font color=green>/ig;
    $Body =~ s/\[blue\]/<font color=blue>/ig;
    $Body =~ s/\[\/blue\]/<\/font color=blue>/ig;
    $Body =~ s/\[orange\]/<font color=orange>/ig;
    $Body =~ s/\[\/orange\]/<\/font color=orange>/ig;
    $Body =~ s/\[purple\]/<font color=purple>/ig;
    $Body =~ s/\[\/purple\]/<\/font color=purple>/ig;
    $Body =~ s/\[white\]/<font color=white>/ig;
    $Body =~ s/\[\/white\]/<\/font color=white>/ig;
    $Body =~ s/\[black\]/<font color=black>/ig;
    $Body =~ s/\[\/black\]/<\/font color=black>/ig;
    $Body =~ s/\[yellow\]/<font color=yellow>/ig;
    $Body =~ s/\[\/yellow\]/<\/font color=yellow>/ig; 

  # ----------------------------
  # Replace quote markup -> html
    $Body =~ s,\[quote\](.*)\[/quote\],<blockquote><font size=1>In reply to:</font><hr><p>$1<p><hr></blockquote><p>,isg;

  # ---------------------------
  # Convert code markup -> html
    $Body =~ s,\[pre\](.*)\[/pre\],<pre>$1</pre><p>,isg;

  # ----------------------------
  # Convert email markup -> html
    $Body =~ s,\[email\](.*)\[/email\],<A HREF="mailto:$1">$1</A>,isg;

  # --------------------
  # Convert the smiley's
    $Body =~s,\[smile\],<img src=\"$config{'images'}/smile.gif\">,isg;
    $Body =~s,\[frown\],<img src=\"$config{'images'}/frown.gif\">,isg;
    $Body =~s,\[wink\],<img src=\"$config{'images'}/wink.gif\">,isg; 

  # ---------------------------
  # Convert url markup -> html
    $Body =~ s,\[url\]http://(.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;
    $Body =~ s,\[url\](.*)\[/url\],<A HREF="http://$1">http://$1</A>,isg;

  # --------------------------------------------------
  # Convert image markup -> html if allow images is on
    if ($config{'allowimages'}) {
      $Body =~ s,\[image\](.*)\[/image\],<IMG SRC="$1">,isg;
    }

  # ---------------------------------------------
  # Get rid of the trailing br's on certain codes
    $Body =~s/<\/blockquote><p><br>/<\/blockquote><p>/g;
    $Body =~s/<\/pre><p><br>/<\/pre><p>/g;
    $Body =~s/<pre><br>/<pre>/g;

  }

    my $FormBody = w3t::url_encode($Body);
    my $FormSubject = w3t::url_encode($Subject);


  # ---------------------------
  # Now we send them their page
    w3t::send_header("Preview your Modifications");

    w3t::table_header("Preview your Modifications");

    print qq~ 
      <table cellspacing=0 border=0 width=100% bgcolor=$config{'tddark'}>
      <tr><td>
      The following is a preview of your modification.  If everything looks ok then you can click 'Continue' and your post will be entered.  If not then use your back button to go back and edit some more. 
      <form method=POST action="$config{'cgiurl'}/modifypost.pl">
      <input type=hidden name=Board value="$Board">
      <input type=hidden name=what value="$what">
      <input type=hidden name=page value="$page">
      <input type=hidden name=view value="$view">
      <input type=hidden name=Number value="$Number">
      <input type=hidden name=mode value="$mode">
      <input type=hidden name=sb value="$sb">
      <input type=hidden name=Subject value="$FormSubject">
      <input type=hidden name=Body value="$FormBody">
      <p>
      </td></tr><tr><td bgcolor=$config{'tdlight'}>
      Subject: $Subject
      <p>
      $Body
      <p>
      <input type=submit value="Continue">
      </td></tr></table>
    ~;

    $sth -> finish();
    w3t::send_footer();


  } else {


# -------------------------------------------------
# Otherwise we are deleting the post so do this sub

  # --------------------
  # Authenticate the user
    w3t::db_connect();
    my %user = w3t::authenticate();
    if (!(defined $user{'Username'}) ) {

      w3t::not_right ("We could not authenticate your Username/Passord.");

    }


  # --------------------
  # Send them their page 
    w3t::send_header("Delete this post");
    w3t::table_header("Delete this post");


    print qq~ 

      You have chosen to delete this post.  If you are sure you want to do this click the button below , otherwise use your back button to return to the last screen.
      <p>
      <form method=POST action="$config{'cgiurl'}/deletepost.pl">
      <input type=hidden name=Username value="$Username">
      <input type=hidden name=Board value="$Board">
      <input type=hidden name=what value="$what">
      <input type=hidden name=page value="$page">
      <input type=hidden name=view value="$view">
      <input type=hidden name=Number value="$Number">
      <input type=hidden name=mode value="$mode">
      <input type=hidden name=sb value="$sb">
      <p>
      <input type=submit value="Yes, I want to delete this post">
      </form>
    ~;


  # ---------------
  # Send the footer
    w3t::send_footer();

}

